<?php
/*
Plugin Name: WM-Bracket
Plugin URI: http://www.liga.parkdrei.de
Description: WM-Bracket for Users
Author: Robert Kapp
Version: 1.0

License: GPL
Author URI: http://www.liga.parkdrei.de/wmbracket

*/
define('WMB_VERSION', "1.0");
include(ABSPATH."/wp-content/plugins/wmbracket/lib.php");


/* create db while the activation process */
add_action('activate_wmbracket/admin.php', 'wmbracket_install');

/* get the options */
if ($optionstring = get_option('wmbracket_options')){
	$wmb_options = wmb_read_option_string($optionstring);} 
else {
	$wmb_options = wmb_set_default_options_array();
	$option_string = wmb_create_option_string($wmb_options);
	update_option("wmbracket_options", mysql_real_escape_string($option_string));
	}
/* get the language file */
if (file_exists(ABSPATH."/wp-content/plugins/wmbracket/language/".$wmb_options['language'].".php")){
	include(ABSPATH."/wp-content/plugins/wmbracket/language/".$wmb_options['language'].".php");
	}

	/* display the view.php */
	function wmb_print_wmbracket($content) {
		global $wmb_options;
		$page_id = $wmb_options['page_id'];
			if(is_page($page_id) AND $page_id!="")
			{
			echo $content;
			include_once ("view.php");
			}
			else	
			{return $content;}
		}
	/* if everything is ok */	
	if (wmb_check_tables()){
		/* print the content */
		add_action('the_content', 'wmb_print_wmbracket');
	}

	/* menu (Tipspiel, Manage) */
	add_action('admin_menu', 'add_wmbracket');

	function add_wmbracket() {
		add_menu_page(__('Options', 'WM-Bracket'), __('WM-Bracket', 'wmbracket'),
		'edit_others_posts', 	'wmbracket', 'wmb_options_page');

		add_submenu_page( 'wmbracket' , __('managebrackets', 'wmbracket'), __('Manage Brackets', 'wmbracket'), 'edit_others_posts',
		'managebrackets', 'wmb_userbrackets_page');

		add_submenu_page( 'wmbracket' , __('wmbinfos', 'wmbracket'), __('Help/Infos', 'wmbracket'), 'edit_others_posts',
		'wmbinfos', 'wmb_info_page');	
		}

	/* version */
	add_action('wp_head', 'add_wmbracket_version');
	function add_wmbracket_version() {
		echo "<meta name='WM-Bracket' content='".WMB_VERSION."' />\n";
	}

/* adminpage main function */
function wmb_options_page() {
global $wpdb, $wmb_options;
/** Actions  */
if ($_REQUEST['action'] == "deletetables" AND !$_REQUEST['confirm']){
	$link = '?page=wmbracket&amp;action=deletetables';
	wmb_admin_message(DeleteTables, 200, 800, 1, $link);
	}
if ($_REQUEST['action'] == "deletetables" and $_REQUEST['confirm'] == "yes"){
	if (wmb_delete_tables()){wmb_admin_message(TablesDeleted, 200, 800);}
	}
if ($_REQUEST['action'] == "createtables"){
	if (wmb_create_tables()){wmb_admin_message(TablesCreated, 200, 800);}
	}
if ($_REQUEST['action'] == "editoptions"){
	/* collect the vars */
	$wmb_options['page_id'] 		= $_POST['page_id'];settype($wmb_options['page_id'], INT);
	$wmb_options['tablewidth'] 		= $_POST['tablewidth'];settype($wmb_options['tablewidth'], INT);
	$wmb_options['language'] 		= $_POST['language'];strip_tags($wmb_options['language']);
	$wmb_options['tablecolor1']		= $_POST['tablecolor1'];strip_tags($wmb_options['tablecolor1']);
	$wmb_options['tablecolor2']		= $_POST['tablecolor2'];strip_tags($wmb_options['tablecolor2']);
	$wmb_options['bordercolor']		= $_POST['bordercolor'];strip_tags($wmb_options['bordercolor']);
	$wmb_options['navigationcolor1']= $_POST['navigationcolor1'];strip_tags($wmb_options['navigationcolor1']);
	$wmb_options['navigationcolor2']= $_POST['navigationcolor2'];strip_tags($wmb_options['navigationcolor2']);
	$wmb_options['fontcolor']		= $_POST['fontcolor'];strip_tags($wmb_options['fontcolor']);
	$wmb_options['linkcolor']		= $_POST['linkcolor'];strip_tags($wmb_options['linkcolor']);
	$wmb_options['tomail']			= $_POST['tomail'];strip_tags($wmb_options['tomail']);
	$wmb_options['bccmail']			= $_POST['bccmail'];strip_tags($wmb_options['bccmail']);
	$wmb_options['showuserbrackets']= $_POST['showuserbrackets'];strip_tags($wmb_options['showuserbrackets']);
	$wmb_options['showlink']		= $_POST['showlink'];strip_tags($wmb_options['showlink']);
	$day					= $_POST['day'];
	$month					= $_POST['month'];
	$year					= $_POST['year'];
	$hour					= $_POST['hour'];
	$minute					= $_POST['minute'];
	settype($day, INT);settype($month, INT);settype($year, INT);settype($hour, INT);settype($minute, INT);	
	$wmb_options['tippfrist'] 		= mktime($hour, $minute, 0, $month, $day, $year);
	
	
	$option_string = wmb_create_option_string($wmb_options);
	update_option("wmbracket_options", mysql_real_escape_string($option_string));
	$option_string = get_option('wmbracket_options');
	$wmb_options = wmb_read_option_string($option_string);
	}
?>
	<!-- color picker -->
	<script language="javascript">
	var which_input;
	// The function name fillColorValue must be used
	// to get the color value. This function takes a string
	// as the color value in a hexidacimal format (e.g. FFFFFF)
	// the function code can be anything the application need.
	function fillColorValue(color){
		document.getElementById(which_input).value = color;
		document.getElementById(which_input+"_div").style.backgroundColor = "#"+color;
	}

	function show_picker(ID, Current_Color, Previous_Color){
		which_input = ID;
		var lnk = "../wp-content/plugins/wmbracket/color_picker/color_picker_files/color_picker_interface.html\
		?cur_color="+Current_Color+"&pre_color="+Previous_Color;
		window.open(lnk, "", "width=465, height=350");
	}
	</script>
	<!-- header -->
	<div class="wrap">
<?php
echo '<h3>'.MainOptions.'</h3>';

if(wmb_check_tables()){
	echo '<p>'.TablesOk.'</p>';
	}
else {
	echo '<p>'.TablesNotOk.'</p>';
	echo '<p><a href="?page=wmbracket&amp;action=createtables">'.CreateTablesLink.'</a></p>';
	}
wmb_print_main_option_form($wmb_options);

echo '<p><a href="?page=wmbracket&amp;action=deletetables">'.DeleteTablesLink.'</a></p>';
}


/* 
 * 
 * manage competitions 
 * 
 * */
function wmb_userbrackets_page() {
/*
 * if there is something wrong with the tables
 */	
if (!wmb_check_tables()){
	echo '<div class="wrap">';
	echo '<h3>'.NoCompleteSetup.'</h3>';
	echo '</div>';
	return FALSE;
	}

	if ($_REQUEST['action'] == "managebracket"){
		$users = wmb_get_users();
		if ($users){
			foreach ($users as $user){
			$username = $user['username'];
			$usermail = $user['usermail'];
				wmb_set_bracket_to_status($username, $_POST[$username]);		
			}}
	}	
	global $wmb_options;
	include(ABSPATH."/wp-content/plugins/wmbracket/styles.php");
	wmb_show_brackets_admin();
}
?>